      subroutine exch_intp(hkl_min,hkl_max,intpl,tmppl)
C
Cji *******************************************************************
Cji Subroutine exch_intp used in cmpt_intrps
Cji Created by Yongchang Ji
Cji Function: exchange the data in f_hkl_ref and store in f_hkl 
C * Input:                                                        *
C *   hkl_min (Integer) -- The minimum index of HKL space.        *
C *   hkl_max (Integer) -- The maximum index of HKL space.        *
C *   f_hkl_ref (complex)    -- the whole result of interpolation 
C * Output:           
C *   f_hkl --- the result of interpolation of each slab
C *  
C *   - Yongchang Ji, Final Version, Aug.2000 -- Jan. 2002             *
C
Cji *******************************************************************

      implicit none

      include 'mpif.h'
      include '../include/allprogs.inc'

C     Subroutine arguments
      integer  hkl_min, hkl_max
      
#ifdef SPREC
      real intpl(3, hkl_min:hkl_max, hkl_min:hkl_max, 
     +0:hkl_max )
      real tmppl(3, hkl_min:hkl_max, hkl_min:hkl_max,
     +     frst_lst_iq(1,iam):frst_lst_iq(2,iam))
#else
      double precision intpl(3, hkl_min:hkl_max, hkl_min:hkl_max, 
     +0:hkl_max )
      double precision tmppl(3, hkl_min:hkl_max, hkl_min:hkl_max,
     +     frst_lst_iq(1,iam):frst_lst_iq(2,iam))
#endif

C     Local variables
      integer  nod, count
      integer  count_array(0:num_nodes-1)
      
      do nod = 0, num_nodes-1
         count_array(nod) = (hkl_max - hkl_min +1)**2 * 3 *
     +        (frst_lst_iq(2,nod) - frst_lst_iq(1,nod) + 1)
      enddo
      
#ifdef SPREC
      call mpi_reduce_scatter(intpl, tmppl, count_array, 
     +MPI_REAL, MPI_SUM, MPI_COMM_WORLD, mpi_err)
#else
      call mpi_reduce_scatter(intpl, tmppl, count_array, 
     +MPI_DOUBLE_PRECISION, MPI_SUM, MPI_COMM_WORLD, mpi_err)
#endif
      
      return
      end subroutine exch_intp
