
C  ***********************************************************************
C  *                                                                     *
C  *              *****     SUBROUTINE FFT_2D_BACK     *****             *
C  *                                                                     *
C  *    COMPUTE IN-CORE 2D REVERSE FFT OF THE FULL-SIZE "FFT" ARRAY      *
C  *                                                                     *
C  *    JANUARY 1992  PURDUE UNIVERSITY VAX 8550, T. BAKER.              *
C  *    LAST MODIFIED  6-JAN-1992 BY T. BAKER.                           *
C  ***********************************************************************
C
      SUBROUTINE FFT_2D_BACK (FFT, IDIM1, IDIM2)
C
      IMPLICIT NONE
C
      INTEGER*4 NN(2), IDIM1, IDIM2, I, J
      REAL*4    FFT(2*IDIM1,IDIM2), WORK, DIV
C  -----------------------------------------------------------------------------
C
      NN(1) = IDIM1
      NN(2) = IDIM2
      DIV   = FLOAT(IDIM1)*FLOAT(IDIM2)
C
      CALL FOURT (FFT, NN, 2, -1, 1, WORK)               ! TRANSFORM THE DATA
      DO J = 1,IDIM2
        DO I = 1,2*IDIM1
          FFT(I,J) = FFT(I,J)/DIV
        ENDDO
      ENDDO
C
      RETURN
      END
